edu.isi.pegasus.planner.parser.dax

## Class ExampleDAXCallback

- java.lang.Object
- - edu.isi.pegasus.planner.parser.dax.ExampleDAXCallback

All Implemented Interfaces:
  Callback

    public class ExampleDAXCallback
    extends java.lang.Object
    implements Callback

An example callback that prints out the various elements in the DAX.

Version:
  $Revision$
Author:
  Karan Vahi

### Field Summary

Fields
`private boolean` `mDone`

### Fields inherited from interface edu.isi.pegasus.planner.parser.dax.Callback

`VERSION`

### Constructor Summary

Constructors
Constructor and Description
`ExampleDAXCallback()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `cbCompoundTransformation(CompoundTransformation compoundTransformation)` Callback when a compound transformation is encountered in the DAX
`void` `cbDocument(java.util.Map attributes)` Callback when the opening tag was parsed.
`void` `cbDone()` Callback when the parsing of the document is done.
`void` `cbExecutable(TransformationCatalogEntry tce)` Callback when a transformation catalog entry is encountered in the DAX
`void` `cbFile(ReplicaLocation rl)` Callback when a replica catalog entry is encountered in the DAX
`void` `cbJob(Job job)` Callback for the job from section 2 jobs.
`void` `cbParents(java.lang.String child, java.util.List parents)` Callback for child and parent relationships from section 3.
`void` `cbWfInvoke(Invoke invoke)` Callback when a invoke entry is encountered in the top level inside the adag element in the DAX.
`java.lang.Object` `getConstructedObject()` Returns an ADag object corresponding to the abstract plan it has generated.
`void` `initialize(PegasusBag bag, java.lang.String dax)` The overloaded constructor.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### mDone

    private boolean mDone

### Constructor Detail

#### ExampleDAXCallback

    public ExampleDAXCallback()

### Method Detail

#### initialize

    public void initialize(PegasusBag bag,
                           java.lang.String dax)

The overloaded constructor.

Specified by:
  `initialize` in interface `Callback`
Parameters:
  `bag` - the bag of initialization objects containing the properties and the logger
  `dax` - the path to the DAX file.

#### cbDocument

    public void cbDocument(java.util.Map attributes)

Callback when the opening tag was parsed. This contains all attributes and their raw values within a map. It ends up storing the attributes with the adag element in the internal memory structure.

Specified by:
  `cbDocument` in interface `Callback`
Parameters:
  `attributes` - is a map of attribute key to attribute value

#### cbWfInvoke

    public void cbWfInvoke(Invoke invoke)

Callback when a invoke entry is encountered in the top level inside the adag element in the DAX.

Specified by:
  `cbWfInvoke` in interface `Callback`
Parameters:
  `invoke` - the invoke object

#### cbJob

    public void cbJob(Job job)

Callback for the job from section 2 jobs. These jobs are completely assembled, but each is passed separately.

Specified by:
  `cbJob` in interface `Callback`
Parameters:
  `job` - the `Job` object storing the job information gotten from parser.

#### cbParents

    public void cbParents(java.lang.String child,
                          java.util.List parents)

Callback for child and parent relationships from section 3.

Specified by:
  `cbParents` in interface `Callback`
Parameters:
  `child` - is the IDREF of the child element.
  `parents` - is a list of IDREFs of the included parents.

#### cbDone

    public void cbDone()

Callback when the parsing of the document is done. It sets the flag that the parsing has been done, that is used to determine whether the ADag object has been fully generated or not.

Specified by:
  `cbDone` in interface `Callback`

#### getConstructedObject

    public java.lang.Object getConstructedObject()

Returns an ADag object corresponding to the abstract plan it has generated. It throws a runtime exception if the method is called before the object has been created fully.

Specified by:
  `getConstructedObject` in interface `Callback`
Returns:
  ADag object containing the abstract plan referred in the dax.

#### cbCompoundTransformation

    public void cbCompoundTransformation(CompoundTransformation compoundTransformation)

Callback when a compound transformation is encountered in the DAX

Specified by:
  `cbCompoundTransformation` in interface `Callback`
Parameters:
  `compoundTransformation` - the compound transforamtion

#### cbFile

    public void cbFile(ReplicaLocation rl)

Callback when a replica catalog entry is encountered in the DAX

Specified by:
  `cbFile` in interface `Callback`
Parameters:
  `rl` - the ReplicaLocation object

#### cbExecutable

    public void cbExecutable(TransformationCatalogEntry tce)

Callback when a transformation catalog entry is encountered in the DAX

Specified by:
  `cbExecutable` in interface `Callback`
Parameters:
  `tce` - the transformationc catalog entry object.